<?php


class	d2p_manager
{
	var	$dbConn;
	var	$lastModifier;
	var	$requests;
	var	$cache;
	var	$transaction;

	function	d2p_manager($connection, $hugeTransaction = false)
	{
		$this->dbConn = $connection;
		$this->transaction = $hugeTransaction;
		$this->lastModifier = NULL;
		$this->requests = array();
		$this->cache = array();
	}

	function	getDatabaseConnection()
	{
		return	$this->dbConn;
	}

	function	objectModified(&$object)
	{
		if	(!($object && is_object($object) && is_a($object, "d2p_data")))
			return	false;

		if	(is_object($this->lastModifier) && ($this->lastModifier->getObjId() != $object->getObjId()))
		{
			$req = $this->lastModifier->createRequest();
			if	($req != "")
			{
				if	($this->transaction && !@pg_query($this->dbConn, $req))
				{
					$this->rollback();
					return	false;
				}

				if	(preg_match("/^DELETE /", $req))
					unset($this->lastModifier);
				else
				{
					$this->lastModifier->isValid();
					if	(	$this->transaction
						&&	preg_match("/^INSERT /", $req)
						&&	!is_array($object->getIdentifierName())
						&&	!strcasecmp(
								$object->getFieldType($object->getIdentifierName()), "serial"
							)
						)
					{
						//FIXME
					}
				}
				array_push($this->requests, $req);
			}
		}
		$this->lastModifier = $object;

		return	true;
	}

	function	newObject($type)
	{
		$tmp = NULL;
		$instr = '$tmp = new d2p_cl_' . $type . '($this, NULL);';
		eval($instr);
		if	(is_object($tmp) && is_a($tmp, "d2p_cl_$type"))
		{
			$idn = $tmp->getIdentifierName();
			if	(!is_array($idn))
			{
				$t = $tmp->getFieldType($idn);
				if	(!strcasecmp($t, "serial"))
				{
					$debcache = -1;
					if	(!is_array($this->cache[$type]))
					{
						$this->cache[$type] = array();
					}
					else
					{
						for	(;is_object($this->cache[$type][$debcache]);$debcache--)
							;
					}
					$tmp->setField($idn, $debcache);
					$this->cache[$type][$debcache] = &$tmp;
				}
			}
			return	$tmp;
		}
		elseif	(is_object($tmp))
			unset($tmp);
		return	NULL;
	}

	function	objectFromBase($type, $identifier)
	{
		if	(is_object($identifier))
			$rid = $identifier->getIdentifier();
		else
			$rid = $identifier;

		if	(is_array($rid))
			$idn = join(",", $rid);
		else
			$idn = $rid;

		if	(is_object($this->cache[$type][$idn]))
			return	$this->cache[$type][$idn];

		$tmp = NULL;
		$instr = '$tmp = new d2p_cl_' . $type . '($this, $rid);';
		eval($instr);
 		if	(is_object($tmp) && is_a($tmp, "d2p_cl_$type") && $tmp->isLoaded)
		{
			if	(!is_array($this->cache[$type]))
				$this->cache[$type] = array();
			$this->cache[$type][$idn] = &$tmp;
			return	$tmp;
		}
		elseif	(is_object($tmp))
			unset($tmp);
		return	NULL;
	}

	function	objectFromForm($type)
	{
		$obj = NULL;
		$instr = '$obj = new d2p_cl_' . $type . '($this, NULL);';
		eval($instr);
		if	(!(is_object($obj) && is_a($obj, "d2p_cl_$type")))
			return	NULL;

		$idn = $obj->getIdentifierName();
		if	(is_array($idn))
		{
			$tmp = array();
			foreach ($idn as $n)
			{
				$cmd  = "global \$form_id__" . $obj->getFieldTable($n) . "__" . $n . ";";
				$cmd .= "\$tmp2 = \$form_id__" . $obj->getFieldTable($n) . "__" . $n . ";";
				eval($cmd);
				$tmp[$n] = $tmp2;
			}
			$obj = $this->objectFromBase($type, $tmp);
		}
		else
		{
			if	(!strcasecmp($obj->getFieldType($idn), "serial"))
				$varname = 'form__';
			else
				$varname = 'form_id__';
			$varname .= $obj->getFieldTable($idn) . "__" . $idn;
			eval(preg_replace("/varname/", $varname, 'global $varname; $tmp = $varname;'));
			$obj = $this->objectFromBase($type, $tmp);
		}
 		if	(is_object($obj) && $obj->isLoaded)
			$obj->getFormInput();
 		else
 			unset($obj);
		return	$obj;
	}

	function	listFromBase($type, $request)
	{
		$tmp = NULL;
		$instr = '$tmp = new d2p_cl_' . $type . '($this, NULL);';
		eval($instr);
		if	(!(is_object($tmp) && is_a($tmp, "d2p_cl_$type")))
		{
			unset($tmp);
			return	NULL;
		}
		$name = $tmp->getIdentifierName();
		unset($tmp);

		$result = @pg_query($this->dbConn, $request);
		if	(!$result)
			return	NULL;

		$tab = array();
		while	($row = pg_fetch_array($result))
		{
			if	(is_array($name))
			{
				$id = array();
				foreach ($name as $pke)
				{
					$id[$pke] = $row[$pke];
				}
				$tmp = $this->objectFromBase($type, $id);
			}
			else
				$tmp = $this->objectFromBase($type, $row[$name]);
			if	(!is_null($tmp))
				array_push($tab, $tmp);
		}
		pg_free_result($result);

		if	(!count($tab))
			return	NULL;

		return	$tab;
	}

	function	commit()
	{
		if	($this->lastModifier)
		{
			$req = $this->lastModifier->createRequest();
			if	($req != "")
			{
				if	(preg_match("/^DELETE /", $req))
					unset($this->lastModifier);
				else
					$this->lastModifier->isValid();
				array_push($this->requests, $req);
				$this->lastModifier = NULL;
			}
		}

		if	(count($this->requests) == 0)
			return	true;

		if	($this->transaction)
			if	(!@pg_query($this->dbConn, "BEGIN TRANSACTION"))
				return	false;
		foreach ($this->requests as $req)
		{
			if	(!@pg_query($this->dbConn, $req))
			{
				@pg_query($this->dbConn, "ROLLBACK TRANSACTION");
				return	false;
			}
		}
		if	(!@pg_query($this->dbConn, "COMMIT"))
			return	false;
		if	($this->transaction && !@pg_query($this->dbConn, "BEGIN TRANSACTION"))
			return	false;

		$this->requests = array();
		$this->lastModifier = NULL;
		return	true;
	}

	function	rollback()
	{
		//FIXME
	}

	function	getHTMLOptions(&$tab, &$selected)
	{
		$list = "";
		for	($i=0;$i<count($tab);$i++)
		{
			$list .= "<OPTION VALUE='" . $tab[$i]->getIdentifier() . "'";
			if	(is_object($selected) && $tab[$i]->getObjId() == $selected->getObjId())
				$list .= " SELECTED";
			$list .= ">" . $tab[$i]->getDescription() . "</OPTION>\n";
		}
		return	$list;
	}
}


?>
